﻿/*
====== READ THIS ========
This code was created as a part of the seminar on 
flash game programing at the University of Munich (Ludwig-
Maximlians Universität.

The code may be used for educational purposes only. All
rights reserverd by the author.

Author: Max Maurer
E-Mail: max.maurer@ifi.lmu.de
(c) 2011
If you have any questions don't hasitate to contact me.
=========================
*/
package {
	import flash.display.MovieClip;
	import flash.text.TextField;
	public class ScoreControl extends MovieClip {
		public var currentPlayer:int=0;
		public var m_score1:int;
		public var m_score2:int;
		public var player1Color:int;
		private const BALL1_X:Number = 65;
		private const BALL1_Y:Number = 55;
		private const BALL2_X:Number = 299;
		private const BALL2_Y:Number = 55;

		public function ScoreControl():void {
			nextPlayer();
			score1=0;
			score2=0;
			player1Color=0;
		}
		
		public function putBall(b:Ball):String {
			if (b.getColor()==3) {
				setStatus("Foul");
				return "foul";
			}
			if (b.getColor()==4) {
				// the black ball was putted
				if (currentPlayer==1) {
					if (score1>=7) {
						setStatus("Player 1 has won the game");
						return "won";
					} else {
						setStatus("Player 1 has lost");
						return "lost";
					}
				} else if (currentPlayer==2) {
					if (score2>=7) {
						setStatus("Player 2 has won the game");
						return "won";
					} else {
						setStatus("Player 2 has lost");
						return "lost";
					}
				}
			}
			// a normal color was putted
			if (player1Color==0) {
				// no player has a color yet
				if (currentPlayer==1) {
					// give him the current color
					player1Color=b.getColor();
				} else {
					// player 1 gets the other color
					if (b.getColor()==2) player1Color=1;
					else player1Color=2;
				}
				var bP1:Ball = new Ball(player1Color);
				bP1.x = BALL1_X;
				bP1.y = BALL1_Y;
				addChild(bP1);
				var bP2:Ball = new Ball(player1Color==2?1:2);
				bP2.x = BALL2_X;
				bP2.y = BALL2_Y;
				addChild(bP2);
			}
			// update score
			if (b.getColor()==player1Color) score1++;
			else score2++;
			return "scored";
		}

		public function get score1():int {
			return m_score1;
		}
		
		public function set score1(s:int):void {
			m_score1=s;
			scorePlayer1.text = ""+m_score1;
		}

		public function get score2():int {
			return m_score2;
		}
		
		public function set score2(s:int):void {
			m_score2=s;
			scorePlayer2.text = ""+m_score2;
		}

		public function nextPlayer():void {
			currentPlayer++;
			if (currentPlayer>2) currentPlayer=1;
			setStatus("Player "+currentPlayer+" make your move!");
		}
		
		public function setStatus(t:String):void {
			txtStatus.text = t;
		}
	}
}